<?php
 
 
 

namespace PhpWA\Protocol\Proto\ContextInfo;

use UnexpectedValueException;




class StatusAttributionType
{
    


    const NONE = 0;
    


    const RESHARED_FROM_MENTION = 1;
    


    const RESHARED_FROM_POST = 2;
    


    const RESHARED_FROM_POST_MANY_TIMES = 3;
    


    const FORWARDED_FROM_STATUS = 4;

    private static $valueToName = [
        self::NONE => 'NONE',
        self::RESHARED_FROM_MENTION => 'RESHARED_FROM_MENTION',
        self::RESHARED_FROM_POST => 'RESHARED_FROM_POST',
        self::RESHARED_FROM_POST_MANY_TIMES => 'RESHARED_FROM_POST_MANY_TIMES',
        self::FORWARDED_FROM_STATUS => 'FORWARDED_FROM_STATUS',
    ];

    public static function name($value)
    {
        if (!isset(self::$valueToName[$value])) {
            throw new UnexpectedValueException(sprintf(
                    'Enum %s has no name defined for value %s', __CLASS__, $value));
        }
        return self::$valueToName[$value];
    }


    public static function value($name)
    {
        $const = __CLASS__ . '::' . strtoupper($name);
        if (!defined($const)) {
            throw new UnexpectedValueException(sprintf(
                    'Enum %s has no value defined for name %s', __CLASS__, $name));
        }
        return constant($const);
    }
}

